unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, StdCtrls, ExtCtrls;

type
  TEditor = class(TForm)
    MainMenu1: TMainMenu;
    mnuArchivos: TMenuItem;
    mnuEdicion: TMenuItem;
    smnuSalir: TMenuItem;
    smnuGuardarComo: TMenuItem;
    N1: TMenuItem;
    mnuFuente: TMenuItem;
    smnuGuardar: TMenuItem;
    smnuAbrir: TMenuItem;
    smnuImprimir: TMenuItem;
    N2: TMenuItem;
    smnuNuevo: TMenuItem;
    Cortar: TMenuItem;
    Copiar: TMenuItem;
    Pegar: TMenuItem;
    mnuParrafo: TMenuItem;
    Izquierda: TMenuItem;
    centrado: TMenuItem;
    derecha: TMenuItem;
    smnucursiva: TMenuItem;
    smnunegrita: TMenuItem;
    smnutachado: TMenuItem;
    smnusubrayado: TMenuItem;
    mnuAyuda: TMenuItem;
    smnuAcercade: TMenuItem;
    barra: TStatusBar;
    redEditor: TRichEdit;
    dialogoGuardar: TSaveDialog;
    dialogoabrir: TOpenDialog;
    dlgfont: TFontDialog;
    N3: TMenuItem;
    smnutipo: TMenuItem;
    dialogoimprimir: TPrintDialog;
    smnucerrar: TMenuItem;
    Timer1: TTimer;
    procedure smnuGuardarComoClick(Sender: TObject);
    procedure smnuAbrirClick(Sender: TObject);
    procedure smnuGuardarClick(Sender: TObject);
    procedure IzquierdaClick(Sender: TObject);
    procedure centradoClick(Sender: TObject);
    procedure derechaClick(Sender: TObject);
    procedure redEditorSelectionChange(Sender: TObject);
    procedure smnucursivaClick(Sender: TObject);
    procedure smnutipoClick(Sender: TObject);
    procedure CortarClick(Sender: TObject);
    procedure CopiarClick(Sender: TObject);
    procedure PegarClick(Sender: TObject);
    procedure smnuAcercadeClick(Sender: TObject);
    procedure smnuNuevoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure smnuSalirClick(Sender: TObject);
    procedure smnuImprimirClick(Sender: TObject);
    procedure smnucerrarClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Editor: TEditor;

implementation

uses AcercaDe;
var
ruta:string;

{$R *.DFM}

procedure TEditor.smnuGuardarComoClick(Sender: TObject);
begin
if dialogoguardar.Execute then
begin
  ruta:=dialogoguardar.FileName;
  redEditor.lines.SaveToFile (dialogoguardar.FileName);
  Editor.caption:='Word Fer 1.0 ['+ruta+']';
end;
end;

procedure TEditor.smnuAbrirClick(Sender: TObject);
begin
if dialogoabrir.Execute then
begin
 redEditor.Visible :=true;
// redEditor.SetFocus ;
 Editor.smnuGuardarComo.enabled:=true;
 Editor.smnuguardar.enabled:=true;
 Editor.smnuimprimir.enabled:=true;
 Editor.smnucerrar.enabled:=true;
 Editor.mnuedicion.enabled:=true;
 Editor.mnuparrafo.enabled:=true;
 Editor.mnufuente.enabled:=true;
 ruta:=dialogoabrir.FileName;
 redEditor.lines.LoadFromFile( dialogoabrir.filename);
 Editor.caption:='Word Fer 1.0 ['+ruta+']';
 barra.panels[0].text:=ruta;
 end;
end;

procedure TEditor.smnuGuardarClick(Sender: TObject);
begin
 if  ruta='' then
  //
  smnuGuardarComoClick(Sender)
 else
 redEditor.lines.SaveToFile (ruta);

end;

procedure TEditor.IzquierdaClick(Sender: TObject);
begin
   Izquierda.checked:=true;
   rededitor.Paragraph.alignment:=taLeftJustify;
end;

procedure TEditor.centradoClick(Sender: TObject);
begin
centrado.checked:=true;
rededitor.Paragraph.alignment:=taCenter ;
end;

procedure TEditor.derechaClick(Sender: TObject);
begin
derecha.checked:=true;
rededitor.Paragraph.alignment:=taRightJustify ;
end;

procedure TEditor.redEditorSelectionChange(Sender: TObject);
begin
 // modificar los radiobottom de justificacion para coordinarlos con el
 //texto seleccionado
if redEditor.paragraph.alignment=tacenter then
 centrado.checked:=true;
if redEditor.paragraph.alignment=Taleftjustify then
izquierda.checked:=true;
if redEditor.paragraph.alignment=Tarightjustify then
derecha.checked:=true;
 // modificar la seleccion de las flechas de las opciones de fuente para
 //coordinarlos con el texto seleccionado

 smnucursiva.checked:=fsitalic in  redEditor.SelAttributes.Style;
 smnunegrita.checked:= fsbold in  redEditor.SelAttributes.Style;
 smnutachado.checked:= fsStrikeout in  redEditor.SelAttributes.Style;
 smnusubrayado.checked:= fsunderline in  redEditor.SelAttributes.Style;

end;

procedure TEditor.smnucursivaClick(Sender: TObject);
begin
(sender as TMenuItem).checked:= not (sender as TMenuItem).checked;
 redEditor.SelAttributes.Style := [];
 if  smnucursiva.checked then
 redEditor.SelAttributes.Style:=redEditor.SelAttributes.Style+[fsitalic];
 if  smnunegrita.checked then
 redEditor.SelAttributes.Style:=redEditor.SelAttributes.Style+[fsbold];
 if  smnusubrayado.checked then
 redEditor.SelAttributes.Style:=redEditor.SelAttributes.Style+[fsunderline];
 if  smnutachado.checked then
 redEditor.SelAttributes.Style:=redEditor.SelAttributes.Style+[fsStrikeout];
end;

procedure TEditor.smnutipoClick(Sender: TObject);
begin
 if dlgfont.execute then
 rededitor.Selattributes.Assign(dlgfont.font);
end;

procedure TEditor.CortarClick(Sender: TObject);
begin
 redEditor.CutToClipboard;
end;

procedure TEditor.CopiarClick(Sender: TObject);
begin
 redEditor.CopyToClipboard;
end;

procedure TEditor.PegarClick(Sender: TObject);
begin
 redEditor.PasteFromClipboard;
end;

procedure TEditor.smnuAcercadeClick(Sender: TObject);
begin
 acerca.showmodal;
end;

procedure TEditor.smnuNuevoClick(Sender: TObject);
begin
 redEditor.Visible :=true;
 redEditor.Clear;
 redEditor.SetFocus ;
 Editor.smnuGuardarComo.enabled:=true;
 Editor.smnuguardar.enabled:=true;
 Editor.smnuimprimir.enabled:=true;
 Editor.smnucerrar.enabled:=true;
 Editor.mnuedicion.enabled:=true;
 Editor.mnuparrafo.enabled:=true;
 Editor.mnufuente.enabled:=true;
 Editor.caption:='Word Fer 1.0 [Sin Nombre]';
// barra.panels[0].text:='[Sin Nombre];
 end;

procedure TEditor.FormCreate(Sender: TObject);
begin
 redEditor.Visible :=false;
 Editor.smnuGuardarComo.enabled:=false;
 Editor.smnuguardar.enabled:=false;
 Editor.smnuimprimir.enabled:=false;
 Editor.smnucerrar.enabled:=false;
 Editor.mnuedicion.enabled:=false;
 Editor.mnuparrafo.enabled:=false;
 Editor.mnufuente.enabled:=false;
 ruta:='';
 barra.panels[0].width:=clientwidth-75;
  end;

procedure TEditor.smnuSalirClick(Sender: TObject);
begin
Editor.close;
end;

procedure TEditor.smnuImprimirClick(Sender: TObject);
begin
if dialogoimprimir.Execute then
begin
  redEditor.Print(ruta);
end;
end;

procedure TEditor.smnucerrarClick(Sender: TObject);
begin
 redEditor.Clear;
 redEditor.Visible :=false;
 Editor.smnuGuardarComo.enabled:=false;
 Editor.smnuguardar.enabled:=false;
 Editor.smnuimprimir.enabled:=false;
 Editor.smnucerrar.enabled:=false;
 Editor.mnuedicion.enabled:=false;
 Editor.mnuparrafo.enabled:=false;
 Editor.mnufuente.enabled:=false;
 Editor.caption:='Word Fer 1.0 [Sin Nombre]'
end;

procedure TEditor.Timer1Timer(Sender: TObject);
begin
barra.panels[1].text:=timetostr(time);
end;

end.
